//***************************************************************
// X10Client 
// Copyright 2005, by Tomoichi Ebata.
//***************************************************************

#include "stdafx.h"
#include <windows.h>
#include <iostream.h>
#include <winsock.h>
#include <stdlib.h>

#define NO_FLAGS_SET 0

#define PORT (u_short) 3055
#define DEST_IP_ADDR "127.0.0.1"
#define MAXBUFLEN 256

void inputError()
{
	printf("Input error\n");
	printf("x10client  [X10addressCommand:X10ActionCommand] [server:port]\n");
	printf("Example:\n");
	printf("	x10client A01:A20 erukan.kobore.com:3055  \n");
	printf("	x10client A01:A20 123.456.789.010:3055 \n");
	printf("	x10client A01:A20 \n");
	printf("	x10client A01:A20 localhost:3055\n");
}

INT main(int argc,char *argv[])
{
	WSADATA Data;
	SOCKADDR_IN destSockAddr;
	SOCKET destSocket;
	int status;
	int numsnt;


	/* initialize the Windows Socket DLL */
	status=WSAStartup(MAKEWORD(1, 1), &Data);
	if (status != 0)
		cerr << "ERROR: WSAStartup unsuccessful" << endl;

	if ((argc < 2) || (argc > 3))
	{
		inputError();
		return (1);
	}

	char sendText[MAXBUFLEN];

	if ((argv[1][3] != ':') || (strlen(argv[1]) != 7))
	{
		inputError();
		return (1);
	}

	memset(sendText, 0, sizeof(sendText));
	memcpy(sendText + 0, "&",1);
	memcpy(sendText + 1, argv[1], 3);
	memcpy(sendText + 4, "\r!", 2);
	memcpy(sendText + 6, argv[1]+4, 3);
	memcpy(sendText + 9, "\n", 1);

	char seps[]   = ":";
	char *token;
	
	int port = PORT;

	unsigned long destAddr = inet_addr(DEST_IP_ADDR);

	if (argc == 3)
	{
		token = strtok( argv[2], seps );

		char hostname_or_ipaddress[30];
		strcpy(hostname_or_ipaddress, token);

		// Making Server Address information
		destAddr = inet_addr(hostname_or_ipaddress);

		struct in_addr iaHost;
		LPHOSTENT lpHostEntry;

		struct in_addr *pinAddr;
	
		iaHost.s_addr = inet_addr(hostname_or_ipaddress);
		if (iaHost.s_addr == INADDR_NONE)
		{
			lpHostEntry = gethostbyname(hostname_or_ipaddress);
			int dummy = GetLastError();

			if (lpHostEntry == NULL)
			{
				cerr << "ERROR: gethostbyname unsuccessful" << endl;
				return (-1);
			}

			pinAddr = (LPIN_ADDR)lpHostEntry->h_addr_list[0];
			destAddr = inet_addr(inet_ntoa(*pinAddr));
		}

		token = strtok( NULL, seps);
		if (token != NULL)
			port = atoi(token);
	}
			
/*
		memcpy(&destSockAddr.sin_addr, &destAddr, sizeof(destAddr));
		destSockAddr.sin_port = htons(BackEndServerPort);
		destSockAddr.sin_family = AF_INET;

*/


	  /* copy destAddr into sockaddr_in structure */
	 memcpy(&destSockAddr.sin_addr, &destAddr, sizeof(destAddr));
	 /* specify the port portion of the address */
	 destSockAddr.sin_port=htons(port);
	 /* specify the address family as Internet */
	 destSockAddr.sin_family=AF_INET;
	 
	 /* create a socket */
	 destSocket=socket(AF_INET, SOCK_STREAM, 0);
	 if (destSocket == INVALID_SOCKET)
	 {
		cerr << "ERROR: socket unsuccessful" << endl;
		status=WSACleanup();
		if (status == SOCKET_ERROR)
			cerr << "ERROR: WSACleanup unsuccessful" << endl;
		return(1);
	}

	cout << "Trying to connect to IP Address: " << endl;

	/* connect to the server */
	status=connect(destSocket, (LPSOCKADDR) &destSockAddr, sizeof(destSockAddr));
	if (status == SOCKET_ERROR)
	{
		cerr << "ERROR: connect unsuccessful" << endl;

		status=closesocket(destSocket);
		if (status == SOCKET_ERROR)
			cerr << "ERROR: closesocket unsuccessful" << endl;
		
		status=WSACleanup();
		if (status == SOCKET_ERROR)
			cerr << "ERROR: WSACleanup unsuccessful"  << endl;
		return(1);
	}

	cout << "Connected..." << endl;

	  /* Send the message to the server */
 
	numsnt=send(destSocket, sendText, strlen(sendText) + 1, NO_FLAGS_SET);
	if (numsnt != (int)strlen(sendText) + 1)
	{
		cout << "Connection terminated." << endl;
		status=closesocket(destSocket);
		if (status == SOCKET_ERROR)
			cerr << "ERROR: closesocket unsuccessful" << endl;
		status=WSACleanup();
		if (status == SOCKET_ERROR)
			cerr << "ERROR: WSACleanup unsuccessful" << endl;
		return(1);
    }

	status=closesocket(destSocket);
	return(0);
  
}
